KDE 4.7 PyKDE API Reference

- KDE's Python API

# GenericInterface Class Reference

`from PyKDE4.solid import *`

Inherits: Solid.DeviceInterface → QObject
Namespace: Solid

## Detailed Description

Generic interface to deal with a device. It exposes a set of properties and is organized as a key/value set.

Warning: Using this class could expose some backend specific details and lead to non portable code. Use it at your own risk, or during transitional phases when the provided device interfaces don't provide the necessary methods.

## Enumerations
PropertyChange | { PropertyModified, PropertyAdded, PropertyRemoved }
## Signals
| conditionRaised (QString condition, QString reason)
## Methods
| __init__ (self, QObject backendObject)
{QString:QVariant} | allProperties (self)
QVariant | property (self, QString key)
bool | propertyExists (self, QString key)
## Static Methods
Solid.DeviceInterface.Type | deviceInterfaceType ()

## Signal Documentation

conditionRaised | ( | QString | condition,
|  | QString | reason
| ) |  |  |

This signal is emitted when an event occurred in the device. For example when a button is pressed.

Parameters:

  | condition | the condition name
  | reason | a message explaining why the condition has been raised

Signal syntax:
  `QObject.connect(source, SIGNAL("conditionRaised(const QString&, const QString&)"), target_slot)`

## Method Documentation

__init__ | ( | self, |
|  | QObject | backendObject
| ) |  |  |

Creates a new GenericInterface object. You generally won't need this. It's created when necessary using Device.as().

Parameters:

  | backendObject | the device interface object provided by the backend

See also:
  Solid.Device.as()

{QString:QVariant} allProperties | ( |  | self ) |

Retrieves a key/value map of all the known properties for the device.

Warning: Using this method could expose some backend specific details and lead to non portable code. Use it at your own risk, or during transitional phases when the provided device interfaces don't provide the necessary methods.

Returns:
  all the properties of the device

QVariant property | ( | self, |
|  | QString | key
| ) |  |  |

Retrieves a property of the device.

Warning: Using this method could expose some backend specific details and lead to non portable code. Use it at your own risk, or during transitional phases when the provided device interfaces don't provide the necessary methods.

Parameters:

  | key | the property key

Returns:
  the actual value of the property, or QVariant() if the property is unknown

bool propertyExists | ( | self, |
|  | QString | key
| ) |  |  |

Tests if a property exist in the device.

Warning: Using this method could expose some backend specific details and lead to non portable code. Use it at your own risk, or during transitional phases when the provided device interfaces don't provide the necessary methods.

Parameters:

  | key | the property key

Returns:
  true if the property is available in the device, false otherwise

## Static Method Documentation

Solid.DeviceInterface.Type deviceInterfaceType | ( |  | ) |

Get the Solid.DeviceInterface.Type of the GenericInterface device interface.

Returns:
  the Processor device interface type

See also:
  Solid.Ifaces.Enums.DeviceInterface.Type

## Enumeration Documentation

PropertyChange

This enum type defines the type of change that can occur to a GenericInterface property.

- PropertyModified : A property value has changed in the device - PropertyAdded : A new property has been added to the device - PropertyRemoved : A property has been removed from the device

Enumerator:

  PropertyModified |
  PropertyAdded |
  PropertyRemoved |